
#include "globdef.h"
#include "mousedef.h"

ROUTINE current_mouse_activity;
ROUTINE par_from_keyboard_routine;
int numinput_flag;
int mouse_task_no;
int mouse_task_info;
int mouse_x;
int mouse_y;
int new_mouse_x;
int new_mouse_y;
int mouse_lbutton_x;
int mouse_rbutton_x;
int mouse_lbutton_y;
int mouse_rbutton_y;
char new_lbutton_state;
char new_rbutton_state;
char lbutton_state;
char rbutton_state;
int leftpressed;
int rightpressed;
int mouse_flag;
int no_of_scro;
SCREEN_OBJECT scro[MAX_SCRO];


void check_mouse_actions(void)
{
int i;
int task_info;
if(kill_all_flag) return;
if(mouse_task_no != -1)return;
if( rbutton_state == new_rbutton_state &&
    lbutton_state == new_lbutton_state )return;
task_info=0;
if(new_rbutton_state==1 && rbutton_state==0)
  {
  task_info=GRAPH_RIGHTPRESSED;
  }
else
  {  
  if(new_lbutton_state==1 && lbutton_state==0)
    {
    task_info=0;
    }
  else
    {
    return;
    }
  }
for(i=0; i<no_of_scro; i++)
  {
  if( scro[i].x1 <= mouse_x && 
      scro[i].x2 >= mouse_x &&      
      scro[i].y1 <= mouse_y && 
      scro[i].y2 >= mouse_y) 
    {
    mouse_task_no=i;
    mouse_task_info=task_info;
    }
  }  

}


void set_button_coordinates(void)
{
mouse_x=new_mouse_x;
mouse_y=new_mouse_y;
if (new_lbutton_state!=0)
  {
  mouse_lbutton_x=new_mouse_x;
  mouse_lbutton_y=new_mouse_y;
  }
if (new_rbutton_state!=0)
  {
  mouse_rbutton_x=new_mouse_x;
  mouse_rbutton_y=new_mouse_y;
  }
}

void set_button_states(void)
{
if( (mouse_task_info&GRAPH_RIGHTPRESSED) == 0)
  {
  if (lbutton_state==0)
    {
    if (leftpressed==BUTTON_IDLE)
      {
      leftpressed = BUTTON_PRESSED;
      lbutton_state=1;
      }
    }
  else
    {
    if(new_lbutton_state == 0)
      {
      if(leftpressed==BUTTON_PRESSED)
        {
        leftpressed = BUTTON_RELEASED;
        lbutton_state=0;
        }
      }  
    }
  }
else
  {    
  if(rbutton_state==0)
    {
    if (rightpressed==BUTTON_IDLE)
      {
      rightpressed = BUTTON_PRESSED;
      rbutton_state=1;
      }
    }
  else
    {
    if(new_rbutton_state == 0)
      {
      if(rightpressed==BUTTON_PRESSED)
        {
        rightpressed = BUTTON_RELEASED;
        rbutton_state=0;
        }
      }
    }
  }
}
