

#define BUTTON_IDLE 0
#define BUTTON_PRESSED 1
#define BUTTON_RELEASED 2
#define DATA_READY_PARM 128

extern ROUTINE current_mouse_activity;
extern ROUTINE par_from_keyboard_routine;
extern int numinput_flag;
extern int mouse_task_no;
extern int mouse_task_info;
extern int mouse_x;
extern int mouse_y;
extern int new_mouse_x;
extern int new_mouse_y;
extern int mouse_lbutton_x;
extern int mouse_rbutton_x;
extern int mouse_lbutton_y;
extern int mouse_rbutton_y;
extern char new_lbutton_state;
extern char new_rbutton_state;
extern char lbutton_state;
extern char rbutton_state;
extern int mouse_hide_flag;
extern int leftpressed;
extern int rightpressed;
extern int mouse_active_flag;
extern int mouse_flag;
extern int no_of_scro;

// Structure for a screen object on which the mouse can operate.
typedef struct {
int no;
int x1;
int x2;
int y1;
int y2;
}SCREEN_OBJECT;
#define MAX_SCRO 32
extern SCREEN_OBJECT scro[MAX_SCRO];





void check_mouse_actions(void);
void open_mouse(void);
void unconditional_hide_mouse(void);
void show_mouse(void);
void set_button_states(void);
